<template>
  <div class="bg-light">
    <b-navbar
      toggleable="lg"
      type="dark"
      class="nav-container bg-light p-0"
    >
      <b-navbar-brand
        href="/"
        class="h-100 w-50 p-0"
      >
        <img
          :src="require('@/assets/images/logo.png')"
          alt=""
          class="navbar-img"
        >
      </b-navbar-brand>

      <b-navbar-toggle target="nav-collapse" />

      <b-collapse
        id="nav-collapse"
        is-nav
        class="w-100 justify-content-end"
      >
        <b-navbar-nav class="ml-auto d-flex flex-wrap navbar-reverse">
          <div class="d-md-flex justify-content-between w-100 align-items-center">
            <b-nav-form class="form-inline my-2 my-lg-0 form_search w-100">
              <div class="d-md-flex w-75">
                <b-form-input
                  v-model="search"
                  class="form-control mr-sm-2"
                  type="search"
                  placeholder="Rechercher un vendeur, un produit ..."
                  aria-label="Search"
                />
                <button 
                  class="btn btn-outline-success my-sm-0 h-100"
                  type="submit"
                  @click="Search()"
                >
                  Rechercher
                </button>
              </div>
              <ul
                v-if="dynamicSearch"
                class="form_suggestions"
              >
                <li v-if="dynamicSearch['produits']">
                  <ul>
                    <li>Produits</li>
                    <li
                      v-for="item in dynamicSearch['produits']"
                      :key="item"
                      @click="clearInput()"
                    >
                      <router-link :to="{ name: 'Detailsproduit', params: { idVendeur: item.vendeur.id, id: item.id }}">
                        {{ item.titre }}
                      </router-link>
                    </li>
                  </ul>
                </li>
                <li v-if="dynamicSearch['vendeurs']">
                  <ul>
                    <li>Vendeurs</li>
                    <li
                      v-for="item in dynamicSearch['vendeurs']"
                      :key="item"
                      @click="clearInput()"
                    >
                      <router-link :to="{ name: 'Profilvendeur', params: { idVendeur: item.id }}">
                        {{ item.utilisateur.pseudo }}
                      </router-link>
                    </li>
                  </ul>                
                </li>
              </ul>
            </b-nav-form>
  
            <b-nav-item-dropdown
              v-if="store.isConnected"
              text="Lang"
              class="dropdown-mobile"
            >
              <template #button-content>
                <span
                  v-if="notifMessages"
                  class="badge-messages"
                >{{ notifMessages }}</span>
                <img 
                  v-if="store.user.contentUrl != '' && store.user.contentUrl != 'undefined'"
                  :src="url + store.user.contentUrl"
                  class="vendeur__img"
                  data-bs-display="static"
                >
                <!-- no img -->
                <img 
                  v-else
                  :src="require('@/assets/images/noimguser.png')"
                  alt=""
                  class="vendeur__img"
                  data-bs-display="static"
                >
              </template>
              <b-dropdown-item>
                <router-link to="/allmessages">
                  Discussions <b-badge class="bg-perso">
                    {{ notifMessages }}
                  </b-badge>
                </router-link>
              </b-dropdown-item>
              <b-dropdown-item v-if="store.user.vendeur == true">
                <router-link to="/profilproduits">
                  Mes produits
                </router-link>
              </b-dropdown-item>
              <b-dropdown-item>
                <router-link to="/mes-commandes">
                  Mes commandes
                </router-link>
              </b-dropdown-item>
              <b-dropdown-item>
                <router-link to="/profil">
                  Paramètres du compte
                </router-link>
              </b-dropdown-item>
              <b-dropdown-item @click.prevent="logout()">
                Se déconnecter
              </b-dropdown-item>
            </b-nav-item-dropdown>
            <b-navbar-nav v-else>
              <router-link
                to="/connexion"
                class="btn-cta btn-connexion"
              >
                Se connecter
              </router-link>
            </b-navbar-nav>
          </div>
            
          <b-navbar-nav class="w-100 mr-auto d-flex justify-content-end">
            <b-nav-item
              v-for="cat in categorieName"
              :key="cat"
            >
              <router-link 
                :to="{ name:'ListingProduitCat', params: { cat: cat.id }}"
                class="m-2 text-uppercase item-nav-cat"
                data-toggle="collapse"
                data-target="#nav-collapse"
              >
                {{ cat.nom }}
              </router-link>
            </b-nav-item>
          </b-navbar-nav>
        </b-navbar-nav>
      </b-collapse>
    </b-navbar>
  </div>
  <div />
  
  <div v-if="currentRouteName == 'Home'" class="container__bandeau">
    <img 
    :src="require('@/assets/images/header-home.png')"
    class="bandeau bandeau--home"
    >
    <div class="container__bandeau--logo">
      <img
          :src="require('@/assets/images/logo.png')"
          alt=""
          class="bandeau--home-logo"
        >
    </div>
  </div>
  <div v-else>
    <img 
      :src="require('@/assets/images/header-pages.png')"
      class="bandeau"
    >
  </div>
</template>

<script>
import axios from 'axios';
import { useStore } from '@/store/store'


export default {
  props: {
    notifMessages: Number,
  },

  setup() {
    let store = useStore();
    return {
        token: store.token
    }
  },

  data() {
    return {
      store: useStore(),
      url: process.env.VUE_APP_URL,
      categorieName: [],
      seller: [],
      search: '',
      propositions: [],
      allProduits: [],
      allVendeurs: []
    }
  },

  computed: {
    // on vérifie sur quelle page nous sommes pour afficher l'image du bandeau en fonction
    currentRouteName() {
        return this.$route.name;
    },

    UpdateVendeur(){
      return this.store.user.vendeur;
    },

    dynamicSearch(){
      if(this.search){
        let searchProduits =  this.allProduits.filter((produit) => produit.titre.includes(this.search));
        let searchVendeurs = this.allVendeurs.filter((vendeur) => vendeur.utilisateur.pseudo.includes(this.search));
        let allResult = [];

        if(searchProduits.length && searchVendeurs.length){
          allResult = {
            'produits': searchProduits,
            'vendeurs': searchVendeurs
          };
        } else if (searchProduits.length) {
          allResult = {
            'produits': searchProduits
          };
        } else if (searchVendeurs.length) {
          allResult = {
            'vendeurs': searchVendeurs
          };
        } else {
          allResult = []
        }
        return allResult;
      } else {
        return 0;
      }
    },
  },

  mounted() {

    // on récupère les catégories à afficher dans la barre de nav
    axios({
      method: 'get',
      url: this.url + "/api/categories/",
    })
    .then(res =>  {
      let arr = res.data['hydra:member'];
      for (let i = 0; i < arr.length; i++) {
        const categorie = arr[i];
        this.categorieName.push(categorie);
      }
    })
    .catch(err => {
        console.log(err);
    });

    //on récupère tous les produits, pour la barre de recherche
    axios({
      method: 'get',
      url: this.url + "/api/produits/?afficher=1",
    })
    .then(res =>  {
      let arr = res.data['hydra:member'];
      for (let i = 0; i < arr.length; i++) {
        const produit = arr[i];
        this.allProduits.push(produit);
      }
    })
    .catch(err => {
        console.log(err);
    });

    //on récupère tous les user, pour la barre de recherche
    axios({
      method: 'get',
      url: this.url + "/api/info_vendeurs/?profil_public=1",
    })
    .then(res =>  {
      let arr = res.data['hydra:member'];
      for (let i = 0; i < arr.length; i++) {
        const vendeur = arr[i];
        this.allVendeurs.push(vendeur);
      }
    })
    .catch(err => {
        console.log(err);
    });

    document.addEventListener('click', this.close);
  },

  methods: {
    clearInput(){
      this.search = '';
    },

    logout(){
      const store = useStore();
      localStorage.removeItem('id');
      store.logout();
      this.$router.push('/connexion');
    },

    Search() {
      this.$router.push('/rechercher/' + this.search);
      this.search = '';
  },

}
}

</script>

<style lang="scss" scoped>

.nav-container {
  margin: auto;
  max-width: 1320px;
  @media (max-width: 1400px){
      max-width: 1140px;
  }
  @media (max-width: 1200px){
      max-width: 960px;
  }
  @media (max-width: 992px){
      max-width: 720px;
  }
  @media (max-width: 768px){
      max-width: 540px;
  }
  @media (max-width: 576px){
      max-width: 540px;
  }
  .navbar-img {
    width: 75%;
  }
  .navbar-reverse {
    flex-direction: column-reverse;
  }
}

.bandeau {
  width: 100%;
  margin: 5% 0%;
   &--home {
    width: 100%;
    height: 60vh;
    object-fit: cover;
    &-logo {
      position: relative;
    }
  }
}
.container__bandeau {
  position: relative;
  &--logo {
    height: 60vh;
    position: absolute;
    right: 0;
    top: 0;
    background-color: #fff;
    display: flex;
    align-items: center;
    @media (max-width: 992px){
        display: none;
    }
  }
}

.item-nav-cat {
  padding: 5px;
  &:hover {
    outline: 1px solid grey;
    outline-offset: -1px;
    border-radius: 5px;
  }
  &.router-link-active {
    outline: 1px solid grey;
    outline-offset: -1px;
    border-radius: 5px;
  }
}
.form_search{
  position: relative;
  height: 36px;
}

.dropdown-mobile {
  margin-top: 50px;
  .badge-messages {
    background-color: #7A8ABA;
    width: 20px;
    height: 20px;
    float: left;
    border-radius: 50%;
    color: white;
    font-size: 13px;
    display: flex;
    align-items: center;
    justify-content: center;
  }
}
.bg-perso {
  background-color: #7A8ABA !important;
}
.btn-connexion {
  width: max-content;
  margin-top: 50px;
}

.form_suggestions {
  position: absolute;
  width: 100%;
  border: 1px solid grey;
  background-color: white;
  padding-left: 0;
  top: 36px;
  z-index: 99;
  ul{
    padding-left: 5px;
    li:first-child {
      font-weight: bold;
    }
    li:not(:first-child) {
      padding-left: 20px;
    }
  }
}

@media (min-width: 540px) {
  .navbar-img {
    width: 40% !important;
  }
  .nav-container {
    .navbar-reverse {
      flex-direction: column;
    }
    .dropdown-mobile {
      margin-top: 0;
    }
  }
  .bandeau {
    margin-top: 0;
    &--home {
      object-position: 40% 20%;
    }
  }
}
@media (min-width: 768px) {
  .btn-connexion {
    margin-top: 0;
  }
}


</style>